config/routes.rb
Rails.application.routes.draw do

  devise_for :users
  resources :posts do
    resources :comments
  end
  root 'posts#index'

  get '/about', to: 'pages#about'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
end

app/models/post.rb
class Post < ApplicationRecord
  has_many :comments, dependent: :destroy
  validates :title, presence: true, length: { minimum:5 }
  validates :body, presence: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController

  def create
    @post = Post.find(params[:post_id])
    @comment = @post.comments.create(params[:comment].permit(:name, :body))

    redirect_to post_path(@post)
  end

  def destroy
    @post = Post.find(params[:id])
    @comment = @post.comments.find(params[:id])
    @comment.destroy

    redirect_to post_path(@post)
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController

  def about
  
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :authenticate_user!, except: [:index, :show]
  before_action :find_post, except: [:index, :new, :create]

  def index
    @posts = Post.all.order('created_at DESC')
  end

  def show
  end

  def new
    @post = Post.new
  end

  def create
    @post = Post.new(post_params)

    if @post.save
      redirect_to post_path(@post)
    else
      render 'new'
    end
  end

  def edit
  end

  def update
    if @post.update(params[:post].permit(:title, :body))
      redirect_to @post
    else
      render 'edit'
    end
  end

  def destroy
    @post.destroy
    redirect_to root_path
  end

  private

    def post_params
      params.require(:post).permit(:title, :body)
    end

    def find_post
      @post = Post.find(params[:id])
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/pages_helper.rb
module PagesHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/comments/_comment.html.haml
.comment.clearfix
  .comment_content
    %p.comment_name
      %strong #{comment.name}
    %p.comment_body #{comment.body}
    %p.comment_title #{ time_ago_in_words(comment.created_at) } Ago

  %p
    - if comment.user == current_user && user_signed_in?
      = link_to 'Delete', [comment.post, comment], method: :delete, class: 'button', data: { confirm: 'Are you sure?'}

app/views/comments/_form.html.haml
= form_for([@post, @post.comments.build]) do |f|
  %p
    = f.label :name
    %br
    = f.text_field :name

  %p
    = f.label :body
    %br
    = f.text_area :body
  %br

  %p
    = f.submit

app/views/layouts/application.html.haml
!!!
%html
  %head
    %title Tumblr
    = csrf_meta_tags
    = stylesheet_link_tag 'application', 'http://fonts.googleapis.com/css?family=Raleway:400,700'
    = stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload'
    = favicon_link_tag 'favicon.ico'
    = javascript_include_tag 'application', 'data-turbolinks-track': 'reload'
  %body
    #sidebar
      %ul
        %li.category #{link_to 'Tumblr', root_path}
        %li #{link_to 'Posts', root_path}
        %li
          =link_to 'About', about_path
        - if !user_signed_in?
          %li.sign_in
            = link_to 'User Login', new_user_session_path

      -# %p.sign_in User Login

    #main_content
      #header
        - if current_page?(root_path) || current_page?(posts_path)
          %p Post Feed
        - elsif current_page?(about_path)
          %p My Site
        - else
          = link_to 'Back to Post Feed', root_path
        - if user_signed_in?
          .buttons
            %button.button
              =link_to 'Make Post', new_post_path
            %button.button
              = link_to 'Sign Out', destroy_user_session_path, method: :delete

      - flash.each do |name, msg|
        = content_tag(:div, msg, class: 'alert')
      = yield

-# <!DOCTYPE html>
-# <html>
-#   <head>
-#     <title>Tumblr</title>
-#     <%= csrf_meta_tags %>
-#     <%= stylesheet_link_tag 'application', 'http://fonts.googleapis.com/css?family=Raleway:400,700' %>
-#     <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
-#     <%= favicon_link_tag 'favicon.ico' %>
-#     <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
-#   </head>
-#
-#   <body>
-#     <%= yield %>
-#   </body>
-# </html>

app/views/pages/about.html.haml
#page_wrapper
  #profile_image
    = image_tag 'profile.jpg'

  #content
    %h1 It's Mr. Stick Figure
    %p
      a;sfhviuehrrruhqewruhbfqklejrbfw;kejrbgq;ejrhbfgnwkejrfg;erg;ejr;
      qwerlkfwejrn;wjenrg;wenrglwknqwlkjfdngw;leknrfg;lwkenfr;glnwef;werg
      wel;kjfnbgkwljebfrgk;jbwekfjbgwsdebfv.ebdflgkwberjhfgbvwljehfrvglwjhbe
      welfjbglkwjhebrlgfjwbefkjgbwejbfrgkwjebfkhwiepufvghwiuenrkjgnw;w;kjerb

app/views/posts/_form.html.haml
= form_for @post do |f|
  - if @post.errors.any?
    #errors
      %h2 #{pluralize(@post.errors.count, 'error')} stopped this post from saving
      %ul
        - @post.errors.full_messages.each do |msg|
          %li
            = msg
  %p
    = f.label :title
    %br
    = f.text_field :title

  %p
    = f.label :body
    %br
    = f.text_area :body

  %p
    = f.submit

app/views/posts/edit.html.haml
#page_wrapper
  %h1 Fix Post

  = render 'form'

app/views/posts/index.html.haml
- @posts.each do |post|
  .post_wrapper
    %h2.title
      = link_to post.title, post
    %p.body
      = truncate(post.body, length: 100)  
    %p.date #{time_ago_in_words(post.created_at)} ago

app/views/posts/new.html.haml
#page_wrapper
  %h1 Make Something

  = render 'form'

app/views/posts/show.html.haml
#post_content
  %h1.title
    = @post.title

  %p.date
    Submitted #{time_ago_in_words(@post.created_at)} ago
    - if user_signed_in?
      | #{link_to 'Edit', edit_post_path(@post)} | #{ link_to 'Delete', post_path(@post), method: :delete, data: { confirm: 'Are you sure?'} }

  %p.body
    = @post.body

  #comments
    %h2 #{ @post.comments.count } Comments
    = render @post.comments
    %h3 Join Discussion:
    = render 'comments/form'